<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php
class Core_Database {
	private static $instance = false;
	private $credentials;
	private $display_errors;
	private $last_exec_time = 0;
    private $dblink;
    private $lastError = 0;
	
	protected $ErrorLog;
	protected $Config;
	
	const err_unable_select_db = 'DB_ERR_UNABLE_SELECT_DB';
	const err_incorrect_credentials = 'DB_ERR_INCORRECT_CREDENTIALS';
	const err_failed_sql = 'DB_ERR_FAILED_SQL';
	const err_query_was_empty = 'DB_ERR_QUERY_WAS_EMPTY';
	
	public function __construct($hostname,$username,$password,$database) {

		$this->hostname = $hostname;
		$this->username = $username;
		$this->password = $password;
		$this->database = $database;

		$this->Config = Core_Config::getInstance();
		$this->ErrorLog = Core_ErrorLog::getInstance();
		
		$this->credentials = $this->Config->Get('dbcon_default');
		$this->display_errors = ini_get('display_errors');
		$this->Connect();
		self::$instance = $this;
	}
	
	public static function getInstance() {
		return self::$instance;
	}
	
	private function Connect () {
		$error = false;
		$this->dblink = mysqli_connect($this->hostname, $this->username, $this->password); 
		if (!$this->dblink) {
			$error = true;
		} else {
			if (mysqli_select_db ($this->dblink,$this->database)) {
				$this->Exec("SET NAMES utf8");
				$this->Exec("SET CHARACTER SET 'utf8'");
			} else {
				$error = true;
				$this->lastError = self::err_unable_select_db;
			}
		}
		if ($error) {
			$this->ErrorLog->Write($this->lastError,'Database');
			return false;
		}
		return true;
	}
	
	public function Exec ($sql, $no_log=false) {
		$result = false;
		
		if ($sql) {
			$stime = explode(" ",microtime());
			$stime = $stime[1] + $stime[0];
			$this->query = $sql;
			$result = $this->dblink->query($sql);
			$etime = explode(" ",microtime());
			$etime = $etime[1] + $etime[0];
			$this->last_exec_time = $etime - $stime;
			/*
			echo '<pre>';
			echo $sql;
			
			echo '</pre>';
			*/
			
			if (!$result && !$no_log && ADMIN ) {
				$this->lastError = self::err_failed_sql;
				$this->ErrorLog->Write($this->lastError." (".$sql.")",'Database');
				echo '<div style="padding:5px;border:solid 1px red;margin-bottom:10px;"><pre>';
				echo '<p>'.$sql.' '.$this->Error().'</p>';
				echo '</pre></div>';
				
			}
			$this->result = $result;
			
		} else {
			$this->lastError = self::err_query_was_empty;
			$this->ErrorLog->Write($this->lastError,'Database');
		}
		return $result;
	}
	
	public function Error () {
		return "MySQL Error #".$this->dblink->errno().": ".$this->dblink->error;
	}
	
	function __destruct() {
		return true;
	}
	
	public function Free ($result) {
		return mysqli_free_result($result);
	}
	
	public function Count ($resource) {
		return mysqli_num_rows($resource);
	}
	
	public function Fetch ($resource) {
		return  $resource->fetch_assoc();
	}

	public function FetchRow ($resource) {
		return  $resource->fetch_row();
	}
	
	public function AffectedRows () {
		return $this->dblink->affected_rows;
	}
	
	public function Escape ($sql) {
		return $this->dblink->real_escape_string($sql);
	}
	
	public function Disconnect () {
		return $this->dblink->close();
	}
	
	public function LastId () {
		return $this->dblink-> insert_id;
	}
	
	public function GetLastExecutionTime () {
		return number_format($this->last_exec_time,5);
	}
	
	public function GetRowCount ($table, $where=false) {
	
		$res = $this->Exec ("SELECT COUNT(*) AS cnt FROM ".$table." ".($where ? " WHERE ".$where." " : ""));
		if ($res) {
			$data = $this->Fetch ($res);
			return (int) $data['cnt'];
		} else return 0;
	}
	
		public function GetRowCountProducts ($table, $where=false) {
		
		$data['cnt'] = 0;
		 
		$res = $this->Exec (	$main_sql = "SELECT goods.*, goods_categories.title AS cat_name FROM goods 
		LEFT JOIN goods_categories ON goods_categories.id=goods.catid LEFT JOIN languages_texts as t ON t.objectid=goods.id AND t.type='goods' AND t.col='title' WHERE 1=1 ".($where?" AND ".$where : ""));
		if ($res) {
			$data = $this->Fetch ($res);
			return isset($data['cnt']) ? $data['cnt'] : 0;
		} else return 0;
	}
	
	
	
	
	public function GetArray ($sql, $idAsKey=false) {
		$result = array();
		$res = $this->Exec ($sql);
		if ($res) {
			$rows = $this->Count($res);
			if ($rows) {
				for ($i=0;$i<$rows;$i++) {
					$row = $this->Fetch ($res);
					$result[$idAsKey&&isset($row['id'])?$row['id']:$i] = $row;
				}
			}
		}
		return $result;
	}
	
	public function GetRow ($table,$id=0,$ref='id') {
		$row = array();
		if ($table) {
		
			$res = $this->Exec ("SELECT * FROM ".$table." WHERE ".$ref." = ".(is_numeric($id)?$id:"'".$id."'")." LIMIT 1");
			if ($this->Count($res)) {
				return $this->Fetch ($res);
			}
		}
		return $row ? $row : false;
	}
	
	public function DeleteRow ($table, $id=0) {
		$str = (is_array($id)) ? implode(',',$id) : $id;
		return $this->Exec("DELETE FROM ".$table." WHERE id IN (".$str.")");
	}
	
	public function GetLastRunTime () {
		return $this->last_exec_time;
	}
	
	public function SetRowOrdering ($id, $table, $field, $direction, $extra_q='') {
		$operator = $direction == 'down' ? '>' : '<';
		$sorting = $direction == 'down' ? 'ASC' : 'DESC';
		$get=$this->Exec("SELECT ".$field." AS poz FROM ".$table." WHERE id = ".$id." ".$extra_q);
		$r=$this->Count($get);
		if ($r) {
			$tmp = $this->Fetch($get);
			$current_ordering=$tmp['poz'];
			$sql = "SELECT id, ".$field." AS d FROM ".$table." WHERE ".$field." ".$operator." ".$current_ordering." ".$extra_q." ORDER BY ".$field." ".$sorting;
			$d=$this->Exec($sql);
			if ($this->Count ($d)) {
				$tmp=$this->Fetch($d);
				$did=$tmp['id'];
				$dord=$tmp['d'];
	
				if ($did) {
					$prev_ordering = intval ($dord);
					$this->Exec ("UPDATE ".$table." SET ".$field." = ".$prev_ordering." WHERE id = ".$id);
					$this->Exec ("UPDATE ".$table." SET ".$field." = ".$current_ordering." WHERE id = ".$did);
					return true;
				}
			}
		} else {
			return false;
		}
	}
	
	public function GetPagingQuery ($rowsPerPage, $itemcount,$page) {
		$pageCount = ceil ($itemcount / $rowsPerPage);
		if ($page > $pageCount) $page = $pageCount-1;
		$offset = $page  * $rowsPerPage;
		$pagingQuery = "  LIMIT ".$offset.",".$rowsPerPage;
		return $pagingQuery;
	}
	
	public function GetPagingQuerySimple ($rowsPerPage,$page) {
	

		$offset = $page  * $rowsPerPage;
		$pagingQuery = "  LIMIT ".$offset.",".$rowsPerPage;
		
		return $pagingQuery;
	}
	
	public function GetSearchString ($str) {
		return $this->Escape(str_replace(array('%','_'),'',$str));
	}
	
	public function CreateSearchQuery ($field, $query, $join="AND") {
		$query = $this->GetSearchString($query);
		if ($query) {
			$keys=explode(" ",$query);
			$keys=Tools_Arrays::removeEmptyArrVal(array_unique($keys));
			if (!empty($keys)) {
				$values=array();
				foreach ($keys as $k){ 
					if (is_array($field)) {
						$tmp=array();
						$str = " ( ";
						foreach ($field as $f){
							$tmp[] = " ".$f." LIKE '%".$this->Escape($k)."%' ";
						}
						$str .= implode('OR',$tmp)." ) ";
					} else {
						$str = " ".$field." LIKE '%".$this->Escape($k)."%' ";
					}
					$values[] = $str;
				}
				return $join." (".implode($join,$values).") ";
			} else return "";
		} else return "";	
	}
	
	public function getNextPosition ($table, $field='position') {
		$res = $this->Exec("SELECT MAX(".$field.") AS mp FROM ".$table);
		$rows = $this->Count($res);
		if ($rows) {
			$d = $this->Fetch($res);
			return intval($d['mp']) + 1;
		} else return 1;
	}
}

$DB = Core_Database::getInstance();
